pcntl_wait
pcntl_wexitstatus
PCNTL Functions
PHP Manual

# pcntl_waitpid

(PHP 4 >= 4.0.7, PHP 5)

pcntl_waitpid — Waits on or returns the status of a forked child

### Description

int pcntl_waitpid ( int `$pid` , int `&$status` [, int `$options` ] )

Suspends execution of the current process until a child as specified by the `pid` argument has exited, or until a signal is delivered whose action is to terminate the current process or to call a signal handling function.

If a child as requested by `pid` has already exited by the time of the call (a so-called "zombie" process), the function returns immediately. Any system resources used by the child are freed. Please see your system's waitpid(2) man page for specific details as to how waitpid works on your system.

### Parameters

`pid`

  The value of `pid` can be one of the following:

  possible values for `pid`
  < -1 | wait for any child process whose process group ID is equal to the absolute value of `pid` .
  -1 | wait for any child process; this is the same behaviour that the wait function exhibits.
  0 | wait for any child process whose process group ID is equal to that of the calling process.
  > 0 | wait for the child whose process ID is equal to the value of `pid` .

  > Note: Specifying -1 as the `pid` is equivalent to the functionality pcntl_wait() provides (minus `options` ).

`status`

  pcntl_waitpid() will store status information in the `status` parameter which can be evaluated using the following functions: pcntl_wifexited(), pcntl_wifstopped(), pcntl_wifsignaled(), pcntl_wexitstatus(), pcntl_wtermsig() and pcntl_wstopsig().

`options`

  The value of `options` is the value of zero or more of the following two global constants OR'ed together:

  possible values for `options`
  WNOHANG | return immediately if no child has exited.
  WUNTRACED | return for children which are stopped, and whose status has not been reported.

### Return Values

pcntl_waitpid() returns the process ID of the child which exited, -1 on error or zero if WNOHANG was used and no child was available

### See Also

- pcntl_fork()
- pcntl_signal()
- pcntl_wifexited()
- pcntl_wifstopped()
- pcntl_wifsignaled()
- pcntl_wexitstatus()
- pcntl_wtermsig()
- pcntl_wstopsig()

pcntl_wait
pcntl_wexitstatus
PCNTL Functions
PHP Manual